#include "bioclass.h"
#include <nextgen/nextgen_v2.h>
#include <curl/curl.h>
#include <chttprequest/chttprequest.h>
#include <html_form/html_classes.h>

void bioclass::traverse_cline(cgiOutStream& CGIStream, const CString& s){
  
}
int bioclass::traverse_tags(cgiOutStream& CGIStream, const CString& extract){
  
  return 1;
}

void bioclass::traverse_post(cgiOutStream& CGIStream){
  
}

bioclass::bioclass(cgiOutStream& CGIStream, pParam_v2 * i_params):  
  ext_param(
	    "HEAD","<html><head><title>BioGraph/PeptIdent</title></head><body bgcolor=white><center><a href=\"http://www.expasy.ch\"><img src=\"http://www.expasy.ch/sgifs/PEOPLE/c24_100x125.gif\"></a></center><hr noshade>\n",
	    "FOOT","<hr noshade><p align=center><font size=-2>BioGraph -  University of Geneva - CUI - All Rights Reserved - 1998<br>written by Daniel Doubrovkine (<a href=\"mailto:doubrov5@cuimail.unige.ch\">doubrov5@cuimail.unige.ch</a>) &amp; Anton Soudovtsev (<a href=\"mailto:soudovt4@cuimail.unige.ch\">soudovt4@cuimail.unige.ch</a>)</font></p></body></html>",
	    0) 
{
  
  params = i_params;  
  if (!getenv("SCRIPT_NAME")) cgi_error(CGIStream, "this is a CGI script, invalid envoronment header");
  
  
}

void bioclass::OutputBioGraph(cgiOutStream& CGIStream){
  CGIStream << "<hr><center><a name=\"biograph\"></a>"
	    << "<applet code=\"BioGraph.class\" name=\"Bio-Graph\" codebase=\"http://cuiwww.unige.ch/~doubrov5/uni/biograph/\" width=\"640\" height=\"480\">\n"
	    << "<param name=\"Peaks1Name\" value=\"PKM/User Input\"></param>\n"
	    << "<param name=\"Peaks2Name\" value=\"PeptIdent\"></param>\n"
	    << "<param name=\"Peaks1\" value=\"" << params->get_entry("P-FIRST") << "\"></param>"
	    << "<param name=\"Peaks2\" value=\"" << params->get_entry("P-SECOND") << "\"></param>"
	    << "<param name=\"Tol\" value=\"" << params->get_entry("TOLERANCE") << "\"></param>"
	    << "</center></applet><br>";
}

void bioclass::OutputAddGraph(cgiOutStream& CGIStream){
  CGIStream << "<div align=\"left\"><font size=\"-1\">\n<ul>\n"
	    << "<li>The topmost graph shows PKM or user input Peptide masses with relative intensities (<font color=\"blue\">blue</font>) together with "
	    << "PeptIdent results (<font color=\"red\">red</font>); <font color=\"orange\">yellow</font> peaks are matching masses between blue and red series. (If you see no red "
	    << "peaks, this means that all masses match, which is normal given that PeptIdent was feeded with the same "
	    << "tolerance as m-tol initial value.)\n"
	    << "<li>The bottom graph is a zoom of the topmost one between mass values you can choose from the two listboxes. Matching masses (in <font color=\"red\">red</font>) have a bigger red circle on the peak.\n"
	    << "<li>If you move the mouse over a peak, the following annotation will appear: mass, intensity, position, sequence, missed-cleavages, missed-cleavage sites (where available).\n"
	    << "<li>The protein name results from the PeptIdent identification.\n"
	    << "<li><b>Grid</b>: show grid on both graphics\n"
	    << "<li><b>Eq</b>: equalize mean values\n"
	    << "<li><b>Log</b>: log(y), apply a loarithm on all intensity values\n"
	    << "<li><b>Scale</b>: show multiply factors dx and dy\n"
	    << "<li><b>Legend</b>: toggle mass, intensity scale / matching mass anotations\n"
	    << "<li><b>m-tol</b>: adjust tolerance for mass values\n"
	    << "<li><b>x-add</b>: displace PKM masses and recalculate matching values\n"	    	   
	    << "<li><a href=\"http://cuiwww.unige.ch/~soudovt4/bio/help.html\">BioGraph Help (in French)</a>\n"
	    << "<li><a href=\"http://cuiwww.unige.ch/~soudovt4/bio\">BioGraph Project Overview</a>\n"
	    << "<li><a href=\"http://cuiwww.unige.ch/~soudovt4/bio/technics.html\">BioGraph Technical Overview</a>\n"
	    << "</ul></font></div>\n";  	   
}

void bioclass::traverse_finale(cgiOutStream& CGIStream){
  CString Action = params->get_entry("ACTION");
  CString PIdent = params->get_entry("P-IDENT");

  CGIStream << "<!--COPYRIGHT\nBioGraph -  University of Geneva - CUI - All Rights Reserved - 1998\nwritten by Daniel Doubrovkine (doubrov5@cuimail.unige.ch) &amp; Anton Soudovtsev (soudovt4@cuimail.unige.ch)\n-->";

  if (Action == "P-BIOGRAPH") {
    CGIStream << get_value("HEAD");
    OutputBioGraph(CGIStream);
    OutputAddGraph(CGIStream);
    CGIStream << get_value("FOOT");
  } else if (Action == "P-IDENT") {
    nextgen_v2 PIdentStream(PIdent);
    if (!PIdentStream.void_read) {
      CGIStream << get_value("HEAD");
      HConsumer Consumer(P_EXTRACT_FORM, CGIStream, PIdentStream.contained);      
      CGIStream << get_value("FOOT");
    } else cgi_error(CGIStream, "unable to retrieve PeptIdent request form");
  } else if (params->get_entry("CONTENT_TYPE") == "multipart/form-data") {
    CGIStream << get_value("HEAD");
    /*
      for (int i=0;i<params->entries_count();i++)
      CGIStream << "[PARAM]:{" << params->get_name(i) << "}={" << params->get_entry(i) << "}" << elf;    
      */        
    CHttpRequest HttpPost;
    HttpPost.SetTimeout(60*10);
    CUrl UrlPost(params->get_entry("P-IDENT"));
    CString PeptIdentURL(UrlPost.GetHost()); PeptIdentURL+=params->get_entry("P-ACTION");
    UrlPost.SetUrl(PeptIdentURL);
    
    //CGIStream << "<base href=\"" << UrlPost.GetScheme() << "://" << UrlPost.GetHost() << "\">\n";
    
    CGIStream << "Executing PeptIdent remotely with " << params->getRawData().StrLength() << " bytes of multipart data from " << UrlPost.GetScheme() << "://" << UrlPost.GetBrute() << ", please be patient..." << elf;
    //CGIStream << params->getRawData() << elf;
    CGIStream.flush();
    cout.flush();
    //HttpPost.SetProxy("cuiproxy.unige.ch:3128");
    HttpPost.SetParameter("Referer",params->get_entry("P-IDENT"));
    HttpPost.SetParameter("User-Agent",getenv("HTTP_USER_AGENT"));
    HttpPost.SetParameter("Accept",getenv("HTTP_ACCEPT"));
    HttpPost.SetParameter("Accept-Encoding",getenv("HTTP_ACCEPT_ENCODING"));
    HttpPost.SetParameter("Accept-Language",getenv("HTTP_ACCEPT_LANGUAGE"));    
    HttpPost.SetParameter("Accept-Charset",getenv("HTTP_ACCEPT_CHARSET"));
    HttpPost.SetParameter("Cookie",getenv("HTTP_COOKIE"));
    HttpPost.SetParameter("Content-type",params->get_entry("CONTENT_TYPE_MULTIPART"));
    HttpPost.SetParameter("Content-length",getenv("CONTENT_LENGTH"));    
    HttpPost.Post(UrlPost, params->getRawData());
    
    cgiOutStream tCGIStream; tCGIStream.Lock();
    CGIStream << "PeptIdent returned " << HttpPost.GetData().StrLength() << " bytes of data." << elf;
    HConsumer Consumer(P_EXTRACT_BODY, tCGIStream, HttpPost.GetData());
    //CGIStream << HttpPost.GetData() << elf;
    
    CGIStream << "<!--COMMENTS\n";
    for (int m=0;m<Consumer.Comments.Count();m++) CGIStream << Consumer.Comments[m] << "\n";
    CGIStream << "-->";      
      
    OutputTables(CGIStream, Consumer.Comments);
    //CGIStream << tCGIStream.Buffer; 
    tCGIStream.Buffer.Free();
    CGIStream << get_value("FOOT");
  } else cgi_error(CGIStream, "inconsistent request");
}

CString& bioclass::RemoveSpaces(CString& sStr){
  CString Result;
  for (int i=0;i<sStr.StrLength();i++)
    if (sStr[i] > ' ') Result+=sStr[i];
  sStr = Result;
  return sStr;
}

void bioclass::OutputTables(cgiOutStream& CGIStream, CVector<CString>& Comments){
  /*
    digest PKM or masses entered manually
    */
  CGIStream << "<a name=\"top\"></a><form action=\"" << getenv("SCRIPT_NAME") << "#biograph\" method=\"POST\" target=\"_new\">\n";
  CGIStream << "<input type=\"hidden\" name=\"action\" value=\"P-BIOGRAPH\">\n";
  /*
    process vectors of values
    */
  CVector<CString> ProteinNames;
  CString ProteinValues;
  CString LastProtein;
  int Checked = 0;  
  for (int i=0;i<Comments.Count();i++){
    CVector<CString> NValueVector; Comments[i].Tokenizer("\n", NValueVector);
    if (Comments[i].StartsWith("PROTEIN")) LastProtein = Comments[i];
    else if (NValueVector[0] == "PEPTIDES") {
      ProteinValues+=a_.o("NAME",LastProtein.asString(), 0);
      ProteinNames+=LastProtein;
      ProteinValues+=!a_;
      ProteinValues+="<input type=\"radio\" name=\"P-SECOND\" ";
      if (!Checked) {ProteinValues += "checked "; Checked = 1;}
      ProteinValues+="value=\"";
      ProteinValues+=LastProtein;
      ProteinValues+="/";
      CString MassValues;
      for (int k=1;k<NValueVector.Count();k++){
	CVector<CString> PVector; NValueVector[k].Tokenizer('/', PVector);	
	MassValues += NValueVector[k];
	MassValues += "<br>";
	/*
	  for (int l=0;l<PVector.Count();l++) {
	  MassValues += "[";
	  MassValues += PVector[l];
	  MassValues += "]";
	  }
	  */	
	if (PVector.Count() >= 1) {
	  ProteinValues+=RemoveSpaces(PVector[1]);
	  ProteinValues+=" 0 ";
	  ProteinValues+=RemoveSpaces(PVector[1]);
	  ProteinValues+=" "; ProteinValues+=PVector[1];
	  /*
	    MC MCField Position Name
	    ProteinValues+=" 0 ? ? ? ";
	    */
	  ProteinValues+=" "; ProteinValues+=RemoveSpaces(PVector[3]);	  
	  if (!PVector[4].StrLength()) PVector[4] = "?";
	  ProteinValues+=" "; ProteinValues+=RemoveSpaces(PVector[4]);
	  ProteinValues+=" "; ProteinValues+=RemoveSpaces(PVector[5]);
	  ProteinValues+=" "; ProteinValues+=RemoveSpaces(PVector[6]);	  	 
	  ProteinValues+=" ";
	}
      }
      ProteinValues += "\"> ";
      ProteinValues += LastProtein;
      ProteinValues += "<blockquote><font size=\"-1\">";
      ProteinValues += MassValues;
      ProteinValues += "[ <a href=\"#top\">Top</a> ] [ <a href=\"#launch\">BioGraph</a> ]</font></blockquote></input>";
      ProteinValues += elf;
    }
  }

  for (int i=0;i<ProteinNames.Count();i++) {
    CString Tmp("#"); Tmp+=ProteinNames[i];
    CGIStream << a_.o("HREF",Tmp.asString(), 0) << ProteinNames[i] << !a_ << elf;
  }
  CGIStream << hr_ << ProteinValues << hr_;

  CString UpFile = params->get_entry("UPFILE");
  CString Masses = params->get_entry("MASSES");
  if (UpFile.StrLength()) {
    int sPos = UpFile.isSubStr("\"Peak Table\"");
    if (sPos >= 0) {
      CGIStream << "PKM Peak Values:" << elf;
      UpFile.StrDelete(0, sPos);
      for (int ii=0;ii<4;ii++) UpFile.ExtractLine();
      CString OriginalSeries;
      while (UpFile.StrLength()) {
	CVector<CString> PeekValues = UpFile.ExtractLine().Tokenizer(' ');
	for (int i=PeekValues.Count()-1;i>=0;i--) {
	  PeekValues[i].StrTrim32();
	  if (!PeekValues[i].StrLength()) PeekValues-=i;
	}
	if (PeekValues.Count())
	  for (int mm=0;mm<4;mm++) {
	    if (mm) OriginalSeries+=" ";
	    OriginalSeries+=PeekValues[mm];
	    CGIStream << "[" << PeekValues[mm] << "]";
	  }
	OriginalSeries+=" 0 ? ? ? ";	
	CGIStream << elf;
	UpFile.ExtractLine();
      }      
      CGIStream << "<hr>";
      CGIStream << "<input type=\"hidden\" name=\"P-FIRST\" value=\"" << OriginalSeries << "\">\n";
    } else cgi_error(CGIStream, "uploaded file is not a .PKM, Peak Table not found");
  } else if (Masses.StrLength()) {    
    CGIStream << "Manual Peak Values:" << elf;
    CString OriginalSeries;
    CVector<CString> PeekValues = Masses.Tokenizer(' ');
    for (int mm=0;mm<PeekValues.Count();mm++) {
      OriginalSeries += PeekValues[mm];
      OriginalSeries+=" 0 ";
      OriginalSeries += PeekValues[mm]; OriginalSeries += " ";
      OriginalSeries += PeekValues[mm];
      OriginalSeries += " 0 ? ? ";
      CGIStream << "[" << PeekValues[mm] << "]";
    }
    CGIStream << elf;
    CGIStream << "<hr>";
    CGIStream << "<input type=\"hidden\" name=\"P-FIRST\" value=\"" << OriginalSeries << "\">\n";
  } else cgi_error(CGIStream, "no valid peek data found (no .PKM or Masses field)");  
 
  CGIStream << "<input type=\"hidden\" name=\"tolerance\" value=\"" << params->get_entry("TOLERANCE") << "\">";
  CGIStream << "<input type=\"hidden\" name=\"mc\" value=\"" << params->get_entry("MC") << "\">";  
  if (Checked) CGIStream << "<a name=\"launch\">Choose</a> a protein above and press <input type=\"submit\" value=\"Launch BioGraph\">";
  else CGIStream << "<b>[no match, nothing to plot, sorry]</b>" << elf;
  CGIStream << "</form>\n";
}

bioclass::~bioclass(void){
 
}

#include <html_base/html_base.cpp>
template class html_base<bioclass>;
