/*
  HConsumer - HTML parser
  */

#ifndef H_CONSUMER
#define H_CONSUMER

#include <cstring/cstring.h>
#include <html_form/tag_base/tag_base.h>
#include <slist/slist_v2.h>

#define P_UNDEFINED 0
#define P_EXTRACT_FORM 1
#define P_EXTRACT_BODY 2

class HConsumer {
private:   
  int POperation;
  int isShowing(void);
  int inForm;
  int inBody;
  int LastToken;
  void ReadNameValue(cgiOutStream& CGIStream, int& curPos, const CString& Token, CString& Name, CString& Value);
  void HParse(cgiOutStream& CGIStream, const CString&);
  void SkipSpaces(cgiOutStream& CGIStream, int&, const CString&);
  CString ReadText(cgiOutStream& CGIStream, int& curPos, const CString& iStr);
  CString ReadString(cgiOutStream& CGIStream, int& curPos, const CString& Token);
  void ParseToken(cgiOutStream& CGIStream, const CString&);
  CString ReadToken(cgiOutStream& CGIStream, int& curPos, const CString& iStr);  
  void onNewTag(cgiOutStream& CGIStream, html_tag&);
  void Dequote(CString&);
  CVector<CString> UsefulTags;
  CString FAction;
public:  
  CVector<CString> Comments;
  void setOperation(int);
  CString getAction(void);
  HConsumer(int Operation, cgiOutStream& CGIStream, const CString&);
  ~HConsumer(void);  
};

#endif
