/* 
   CDate.h
   */

#ifndef C_DATE_H
#define C_DATE_H

#include <time.h>
#include "../cstring/cstring.h"

class CDate {
private:
  time_t time_t_time;
  struct tm * tm_time; 
  void Protect(void);
public:
  const char * AscTime(void);
  CDate(void);
  CString& Map(const CString& Expression, CString& Target);
  CString& Year(CString& Target);
  CString& Month(CString& Target);
  CString& Day(CString& Target);  
  CString Map(const CString&);
  void GetVariable(CString&);
  const char * DayEnglish(int);
  const char * DayEnglishShort(int);
  const char * MonthEnglish(int);
  const char * MonthEnglishShort(int);
  const char * DayFrench(int);
  const char * DayFrench(void);
  const char * MonthFrench(int);
  const char * MonthFrench(void);
  int DayOfWeek (int year, int month, int day);
  const char * DayEnglish(void);
  const char * DayEnglishShort(void);
  const char * MonthEnglish(void);
  const char * MonthEnglishShort(void);
  int DayOfWeek(void);
};

#endif
