/*
  CCertif.cpp
  */

#include "certif.h"
#include "../platform/platform.h"
#include "../cgiout/cgiout.h"
#include "../nextgen/nextgen_v2.h"
#include "../html_form/html_classes.h"

#ifdef ANSI
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#endif

#define UnregBinary "AEINIAL@JBGE@FIHLG@CFGLMCDCMMAAALNHHIDAALEGIMOICIBBCKAGDHIHOOGEDHK@BHGKLDCMJAKMMN@"
#define UnregCertif "BFCEGENGAEEGKBIFMHCLCENJINMHBBMMJKEDJKIHGGKMKDILM@LI@LAKDILLIF"
#define ManageCertif "KCGJLHNMFOMDDO@KFEOFEFL@KBJA"

CCertif::CCertif(const CString& iCategory){
#ifndef ANSI
  WSADATA W;
  WSAStartup (0x101, &W);
#endif
  Category = iCategory;
  isCertified = 0;
}

CCertif::~CCertif(void){
#ifndef ANSI
  WSACleanup();
#endif

}

CString CCertif::CalculateCertif(void){
  return CalculateCertif(1);
}

CString CCertif::CalculateCertif(int Encrypt){
  char * lName = new char[1024];
  gethostname(lName, 1024);
  CString LocalName(lName);
  delete(lName);	
  struct hostent *hp;
  char ** p;
  CString Result;	
  hp = gethostbyname(LocalName.asString());	
  if (hp) 
    for (p = hp->h_addr_list; *p != 0; p++) {
      struct in_addr in;
      char **q;
      (void) memcpy(&in.s_addr, *p, sizeof (in.s_addr));
      Result+=inet_ntoa(in);
      Result+="\t";
      Result+=hp->h_name;
      for (q = hp->h_aliases; *q != 0; q++) {
	Result+=" ";
	Result+= (char *) *q;
	Result+= " ";
      }
    }
#ifdef ANSI
  Result+="\tUNIX";
#else
  Result+="\tWINNT";
#endif
  if (Category.StrLength()) Result+=Category;
  if (Encrypt) {
    Result.Encrypt();
    Result.Encrypt();
  }
  return Result;
}

int CCertif::Certify(void){  
  CString CertifFile(MakeCertifFile());
  nextgen_v2 CertifGen(CertifFile);  
  if (!CertifGen.void_read && Certify(CertifGen.contained)) return 1;
  isCertified = 0;
  return 0;
}

int CCertif::Certify(const CString& Key){
  CString ICertif = CalculateCertif(0);	
  CVector<CString> ICertifVector(ICertif.Tokenizer('\t'));
  CString ICertifResult;
  for (int i=ICertifVector.Count()-1;i>=0;i--) ICertifResult+=ICertifVector[i];	
  ICertifResult.StrTrim32();
  CString DKey(Key); DKey.Decrypt(); DKey.Decrypt(); DKey.StrTrim32();
  if (DKey == ICertifResult) {
    isCertified = 1;
    return 1;
  } else {
    isCertified = 0;
    return 0;
  }
}

void CCertif::CertifyFail(cgiOutStream& CGIStream){  
  long int prout = 0;
  unsigned int i = 0;
  for (i=0;i<strlen(UnregBinary);i++) prout+=UnregBinary[i];
  for (i=0;i<strlen(UnregCertif);i++) prout+=UnregCertif[i];
  for (i=0;i<strlen(ManageCertif);i++) prout+=ManageCertif[i];
  if (!(strlen(UnregBinary)+strlen(UnregCertif)+strlen(ManageCertif))||(prout != 12300)) {int l=0xFF; for (int i=0;i<l*l;i++) CGIStream << (char) ((char *) this)[i]; }
  CGIStream << h1_ << center_ << CString(UnregBinary).Decrypt() << !h1_;
  CString cmdl(getenv("SCRIPT_NAME")); cmdl+=CString(ManageCertif).Decrypt();
  CGIStream << CString(UnregCertif).Decrypt() << a_.o("HREF",cmdl.asString(),0) << cmdl << !a_ << !center_ << elf;
}

CString CCertif::MakeCertifFile(void){
#ifdef ANSI
  CString CertifFile(".certificate");
#else
  CString CertifFile("certif");
  if (Category == "agnes") CertifFile+=".agn";
#endif 
  if (Category == "irma") CertifFile+=".irm";
  else if (Category == "asearch") CertifFile+=".alk";
  return CertifFile;
}

int CCertif::WriteCertificate(const CString& Certificate){
  CString CertifFile(MakeCertifFile());
  if (Certify(Certificate)) {
    ofstream OStream(CertifFile.asString(), ios::out | ios::trunc, filebuf::openprot);
    OStream << Certificate;
    isCertified = 1;
    return 1;
  } else return 0;
}

int CCertif::Certified(void){
  return isCertified;
}
