#ifndef ccontainer_h
#define ccontainer_h

#include "../../platform/platform.h"
#include "../../platform/cgi_aid.h"
#include "../../cvector/cvector.h"
#include "../../cstring/cstring.h" 

#include "centrymultiple.h"
#include "../../chashtable/chashtable.h"

class entry_manager {
  friend ostream& operator<<(ostream& out, const entry_manager&);
public:
  CStringHashTable Singles;
  CHashTable<CEntryMultiple> Multiples;

  void add_value(const CString& name, const CString& value);
  CString make_equiv_path(const CString& structure);
  CString Root;
  entry_manager(void);
  entry_manager(entry_manager&);
  ~entry_manager(void);
  
  void set_value(const CString& name, const CString& value);
  void set_value(const CString& name, const CString& value, int fail, int warning);  

  CString get_value(const CString& name) const;
  CString get_value(int index) const;
  CString get_name(int index) const;
  
  void add_value(const CString& class_name, const CString& name, const CString& value);
  void set_value(const CString& class_name, const CString& name, const CString& value, int fail, int warning);
  void set_value(const CString& class_name, const CString& name, const CString& value);
  CString get_value(const CString& class_name, const CString& name) const;
  CString get_value(const CString& class_name, int index) const;
  CString get_name(int class_index, int index) const;
  CString get_name(const CString& class_name, int index) const;
  CString get_value(int class_index, int index) const;
  
  CString get_class(int index) const;	

  int class_count(void);
  int class_count(int class_index);
  int class_count(const CString& class_name);

  int find_single(const CString& class_name) const;
  int find_multiple(const CString& class_name) const;
  int entries_count(void);
  void clear(void);

  void del_value(const CString& class_name);
};

#endif
