#include "cgi_admin.h"
#include "../../cvector/cvector.h"
#include "../../nextgen/nextgen_v2.h"
#include "../../platform/cgi_aid.h"  
#include "../../html_form/html_classes.h"

cgi_admin_manager * current_cgi_admin_manager = 0;

void output_current_admins(cgiOutStream& CGIStream){
  if (current_cgi_admin_manager) current_cgi_admin_manager->output_admins(CGIStream);
  else {
    current_cgi_admin_manager = new cgi_admin_manager();
    current_cgi_admin_manager->output_admins(CGIStream);
  }
}

cgi_admin_manager::cgi_admin_manager(void){
  current_cgi_admin_manager = this;
  fill_admin();
}

cgi_admin_manager::~cgi_admin_manager(void){
  if (current_cgi_admin_manager == this) current_cgi_admin_manager = 0;
}

int cgi_admin_manager::admin(const CString& class_name, const CString& category){  
  if (!(entry_manager::get_value(category, class_name).StrLength())) return 0; else return 1;
}

void cgi_admin_manager::output_admins(cgiOutStream& CGIStream){
  CGIStream << hr_ << "retreiving administration equivalence structures:" << hr_;
  for (int i=0;i<entry_manager::class_count();i++){
    CGIStream << entry_manager::get_class(i);
    for (int j=0;j<entry_manager::class_count(i);j++) {
      CGIStream << " : " << entry_manager::get_name(i, j);
    }
    CGIStream << elf;
  } 
}

void cgi_admin_manager::add_admin(const CString& class_, const CString& category){ 
  if (class_.StrLength()&&(class_[0]!='#')) {
    CVector<CString> Tokens; category.Tokenizer('+',Tokens);
    for (int i=0;i<Tokens.Count();i++){		
      entry_manager::add_value(Tokens[i], class_, Tokens[i]);
    }
  }
}

void cgi_admin_manager::fill_admin(void){
  equiv_file = entry_manager::make_equiv_path("admin.struct");
  nextgen_v2 hfile(equiv_file);
  CVector<CString> Tokens;
  CString s;
  while (!hfile.feofc()) {
    s = hfile.read_line();
    s.StrTrim32();	
    s.Tokenizer(',', Tokens);	
    if (Tokens.Count() == 2)
      add_admin(Tokens[0], Tokens[1]);
  }
}

int cgi_admin_manager::write_full_admin(const CString& AdminClass, const CString& Equiv){
  if ((!AdminClass.StrLength())||(!Equiv.StrLength())) return 0;
  if (!equiv_file.StrLength()) {
    current_cgi_admin_manager = this;
    equiv_file = entry_manager::make_equiv_path("admin.struct");
  }
  ofstream outfile(equiv_file.asString(), ios::out | ios::app, filebuf::openprot);
  if (!outfile.bad()) {    
    outfile << AdminClass.asString() << "," << Equiv.asString() << endl;
    return 1;
  } else return 0;
}

int cgi_admin_manager::write(void){
  return write(entry_manager::make_equiv_path("admin.struct"));
}


int cgi_admin_manager::write(const CString& container){
  ofstream hfile2(container.asString(), ios::out | ios::trunc, filebuf::openprot);
  if (!hfile2.bad()) {
    for (int i=0;i<entry_manager::class_count();i++){
      for (int j=0;j<entry_manager::class_count(i);j++) {
	hfile2 << entry_manager::get_name(i, j) << "," << entry_manager::get_class(i) << "\n";	
      }
    }
    return 1;
  } else return 0;
}
