#include "html_base.h"
#include "../cgiout/cgiout.h"
#include "../platform/platform.h"
#include "../platform/cgi_aid.h"
#include "../class_entry/ext_param/ext_param.h"

template <class T>
void html_base<T>::traverse_tags(cgiOutStream& CGIStream, T * container_class, const CString& s){	
  CString Result;
  if (1) {
  int p_left = 0;
  int left = s.isSubStr("<$--", 0);
  while (left >= 0) { 
    int right = s.isSubStr("--$>", left);
    if (right >= 0) {
      Result+=s.Copy(p_left, left - p_left);
      left+=strlen("<$--");
      CString Extract = s.Copy(left, right-left);
      if (Extract.StartsWith("RANDOM")){
	Extract.StrDelete(0, strlen("RANDOM"));
	CVector<CString> RandomTokens;
	Extract.Tokenizer("-$-", RandomTokens);
	struct tm *newtime; time_t aclock;
	time(&aclock); newtime = localtime(&aclock);
	int RNDVal = newtime->tm_sec % RandomTokens.Count();
	Result+=RandomTokens[RNDVal];	
      } else {
	Result+="<$--";
	Result+=Extract;
	Result+="--$>";
      }
      p_left = right + strlen("--$>");
      left = s.isSubStr("<$--", p_left);      
      } else break;
  }
  Result+=s.asString()+p_left;
  }
  if (1) {
    int p_left = 0;
    int left = Result.isSubStr("<!--", 0);
    while (left >= 0) { 
      int right = Result.isSubStr("-->", left);
      if (right >= 0) {      
	CGIStream << Result.Copy(p_left, left - p_left);
	left+=strlen("<!--");
	CString Extract = Result.Copy(left, right-left);
	if (!(Extract.StartsWith("SET"))) {
	  if ((!Extract.StrLength())||(!(container_class->traverse_tags(CGIStream, Extract)))) 
	    CGIStream << "<!--" << Extract << "-->";
	}
      p_left = right + strlen("-->");
      left = Result.isSubStr("<!--", p_left);      
      } else break;
    }
    CGIStream << Result.asString() + p_left;
  }
}

template <class T>
html_base<T>::html_base(cgiOutStream& CGIStream, const CString& a_html_document, T * container_class, const CVector<CString>& argv){
  html_base_init(CGIStream, a_html_document, container_class, argv, 1);
}

template <class T>
html_base<T>::html_base(cgiOutStream& CGIStream, const CString& a_html_document, T * container_class, const CVector<CString>& argv, int process_post){
  html_base_init(CGIStream, a_html_document, container_class, argv, process_post);
}

template <class T>
void html_base<T>::html_base_init(cgiOutStream& CGIStream, const CString& a_html_document, T * container_class, const CVector<CString> & argv, int process_post){ 
  html_document = a_html_document;  
  for (int i=3;i<argv.Count(); i++) {
    container_class->traverse_cline_internal(CGIStream, argv[i]);
    container_class->traverse_cline(CGIStream, argv[i]);
  }  
  retreive_html_document(container_class->equivs->get_value(CGIStream, "Cache", 0), container_class->get_value("CACHED").Val());
  if (!contents.StrLength()) cgi_error(CGIStream, "error retreiving html document");
  container_class->traverse_options(contents);  
  container_class->traverse_after_options(CGIStream);
  if ((process_post)&&(container_class->params->isPost() == 1)) {
    container_class->traverse_post(CGIStream);
  }
  traverse_tags(CGIStream, container_class, contents);
  common_footer(CGIStream, 1);  
}

template <class T>
html_base<T>::html_base(cgiOutStream& CGIStream, CString& cContents, const CVector<CString>& argv, T * container_class){
  contents = cContents;  
  for (int i=3;i<argv.Count(); i++) {
    container_class->traverse_cline_internal(CGIStream, argv[i]);
    container_class->traverse_cline(CGIStream, argv[i]);
  }  
  if (!error_raised) container_class->traverse_options(contents);    
  if (!error_raised) container_class->traverse_after_options(CGIStream); 
  if ((!error_raised) && (container_class->params->isPost() == 1)) container_class->traverse_post(CGIStream);
  if (!error_raised) traverse_tags(CGIStream, container_class, contents);  
}

template <class T>
html_base<T>::html_base(cgiOutStream& CGIStream, const CString& a_html_document, T * container_class, int argc, char * argv[]){ 
  html_document = a_html_document;
  for (int i=3;i<argc; i++) {
    container_class->traverse_cline_internal(CGIStream, argv[i]);
    container_class->traverse_cline(CGIStream, argv[i]);
  }
  retreive_html_document(container_class->equivs->get_value(CGIStream, "Cache", 0), container_class->get_value("CACHED").Val());    
  if (!contents.StrLength()) cgi_error(CGIStream, "error retreiving html document");  
  container_class->traverse_options(contents);  
  container_class->traverse_after_options(CGIStream);
  if (container_class->params->isPost() == 1){
    container_class->traverse_post(CGIStream);
  }
  traverse_tags(CGIStream, container_class, contents);
  common_footer(CGIStream, 1);  
}

template <class T>
html_base<T>::~html_base(void){
  
}

template <class T>
void html_base<T>::retreive_html_document(const CString& cache, int cached){    
  nextgen_v2 html(html_document, cache, cached);  
  contents = html.contained;
}

template class html_base<ext_param>;

