/*
  scripting management host
  */

#include "../cgiout/cgiout.h"
#include "../platform/platform.h"
#include "../mozilla/mozilla_v2.h"
#include "../class_entry/cgi_equiv/cgi_equiv.h"
#include "../class_entry/cgi_admin/cgi_admin.h"
#include "../class_entry/cgi_access/cgi_access.h"

#define M_HOST_EQUIV "manage"

#define M_AGNES 1
#define M_GUEST 2
#define M_FORUM 3
#define M_LINKS 4
#define M_IRMA 5
#define M_ASEARCH 6

class MHost {
private:
  CString Cmd;
  int Type;
  cgi_access_manager Access;
  cgi_admin_manager Admin;
  void ProcessPost(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void ProcessPostAgnes(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void ProcessPostGuest(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void ProcessPostLinks(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void ProcessPostForum(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void ProcessPostOther(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&, const CString&, const CVector<CString>&);
  void ProcessGet(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void AgnesAddForm(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);  
  void OtherAddForm(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&, const CString&, const CString&);  
  void PasswordInput(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void StrOk(cgiOutStream& CGIStream) const;
  void StrOk(cgiOutStream& CGIStream, const CString&) const;
  void StrOp(cgiOutStream& CGIStream, const CString&) const;
  void StrOp(cgiOutStream& CGIStream, const CString& StrC, const CString& StrV) const;
  void StrError(cgiOutStream& CGIStream, const CString&) const;
  void StrError(cgiOutStream& CGIStream) const;
  int CheckAdminPassword(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void PassChangeForm(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void ProcessPostPasswd(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void AliasSelect(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void GAEntry(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void GAPostEntry(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void GAPostCache(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void GAPasswd(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void GADelete(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void GACache(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void GAEmail(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&, const CString&);
  int GAPostCommon(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs, CString&);
  void GAPostDelete(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void GAPostEmail(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  CString GAMakeRoot(cgiOutStream& CGIStream, const CString& Victim, cgi_equiv_manager& Equivs);
  void GATemplate(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&, const CString&);
  void GAPostTemplate(cgiOutStream& CGIStream, pParam_v2&, cgi_equiv_manager&);
  void ProcessCertif(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  int ProcesPostCertif(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void GAGeneral(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs, int);
  void GAPostGeneral(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& Equivs);
  void MakeDirectory(cgiOutStream& CGIStream, const CString& Tmp);
  CString MakeCertifCategory(void);
public:
  MHost(cgiOutStream& CGIStream, int mType);
  CString HostId(void);
  void Operate(cgiOutStream& CGIStream, pParam_v2& Params, cgi_equiv_manager& equivs); 
};
