#include "cgi_extern.h"
#include "../cgiout/cgiout.h"

#ifdef ANSI
#include <iostream.h>
#include <sys/wait.h>
#else
#include <time.h>
#include <process.h>
#endif

#include "../cdate/cdate.h"

CString exec_name;
CString init_dir;
CDate Today;

#include "../html_form/html_classes.h"
#include "../cvector/cvector.cpp"
#include "../slist/slist_v2.cpp"
#include "../chashtable/chashtable.cpp"

template class ilist<char *>;
template class ilist<int *>;
template class ilist<void *>;

template class CVector<CString>;
template class CVector<long>;
template class CVector<int>;
template class CVector<CStringVector>;

template class CHashTable<CString>;
template class CHashTable<CEntryMultiple>;

template ostream& operator<<(ostream& out, const CVector<CString>& rhs);

#define lib_version "MV4 Lib v4.1"

#ifdef ANSI
  char ** _environ = environ;
#endif

int debug = 0;
int debug_cpp = 0;
int error_raised = 0;

char * DayEnglish(int Day){
  if (Day == 0) return "Monday";
  else if (Day == 1) return "Tuesday";
  else if (Day == 2) return "Wednesday";
  else if (Day == 3) return "Thursday";
  else if (Day == 4) return "Friday";
  else if (Day == 5) return "Saturday";
  else if (Day == 6) return "Sunday";
  else return "";
}

char * MonthEnglish(int Month){
  switch(Month) {
  case 0: return "January";
  case 1: return "February";
  case 2: return "March";
  case 3: return "April";
  case 4: return "May";
  case 5: return "June";
  case 6: return "July";
  case 7: return "August";
  case 8: return "September";
  case 9: return "October";
  case 10: return "November";
  case 11: return "December";
  default: return "";
  }
}

int DayOfWeek (int year, int month, int day){
  static int t[] = {0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4};
  year -= month < 3;
  return (year + year/4 - year/100 + year/400 + t[month-1] + day)%7;
}

char * protect(char * iStr) {
  if (iStr) return iStr; else return "(void)";
}

void common_exit(cgiOutStream& CGIStream){  
  if (CGIStream.SocketOutput) {
    CGIStream << "\4\n";
    CGIStream.toSTALL();
  } else {
    CGIStream.flush();
    exit(0);
  }
}

#ifdef linux
int max(int first, int second){
  if (first > second) return(first); else return(second);
}
#endif

#include "../class_entry/cgi_equiv/cgi_equiv.h"

void common_footer(cgiOutStream& CGIStream, int par){
  if (current_cgi_equiv_manager){    
    
    CString Banner = current_cgi_equiv_manager->get_value(CGIStream, "BANNER", 0);
    if (Banner.StrLength()) {
	CGIStream << p_.o("align","center",0)
	<< a_.o("HREF","http://www.vestris.com\" target=_top", 0)
	<< img_.o("SRC", Banner.asString(), 0)
	<< !a_ << !p_;

	/*
      CGIStream << "<center><form target=\"new\"method=\"POST\" action=\"http://www.cgi-resources.com/rate/index.cgi\">\n"
		<< "<input type=\"hidden\" name=\"link_code\" value=\"01582\">\n"
		<< "<input type=\"hidden\" name=\"category_name\" value=\"Programs and Scripts/Remotely Hosted/Bulletin Board Message Systems/\">\n"
		<< "<input type=\"hidden\" name=\"link_name\" value=\"aGNeS News Forum BBS\">\n"
		<< "<input type=\"hidden\" name=\"referer\" value=\"\">\n"
		<< "<select name=\"rating\"><option selected>10<option>9<option>8<option>7<option>6<option>5<option>4<option>3<option>2<option>1</select>\n"
		<< "<input type=\"image\" name=\"submit\" alt=\"Vote!\" align=\"absmiddle\" src=\"http://www.vestris.com/agnes.new/images/vote.gif\" border=\"0\" width=\"88\" height=\"31\">\n"
		<< "</form></center>\n";
      */
      if (par) CGIStream << p_.o("align","center",0) << font_.o("size","1",0);      
      CGIStream << lib_version << " (" << __DATE__ << ") ";     
      CGIStream << "  " << a_.o("HREF","mailto:dblock@vestris.com",0) << "dB." << !a_ << " - "
		<< a_.o("HREF","http://www.vestris.com",0) << "Vestris Inc" << !a_
		<< ". - 1994-98 - ICQ#7084855 - All Rights Reserved" << br_;
      if (current_cgi_equiv_manager->get_value(CGIStream, "NOCOUNTER", 0).Val() != 1) {
	CGIStream << "CGI global counter: " 
		  << img_.o("src","http://www.vestris.com/cgi-counter/Count.cgi?cache=F&display=counter&ft=0&md=10&dd=E&df=cgi.dat",
			    "align","absmiddle",0) << elf;
      }	
      if (par) CGIStream << !p_ << !font_ << "\n";
    }
  }
}

void cgi_moved(cgiOutStream& CGIStream, const CString& link){    
  cout << "Location: " << link << "\n\n";  
  exit(0);
}

void cgi_error(cgiOutStream& CGIStream, const CString& strerror) { 
  error_raised = 1;
  CGIStream << "<EM><FONT SIZE=4><B>" << strerror << "</EM></FONT>"
	    << "<BR><font size=-1>Please use the <EM>Back</EM> button to return to previous page.<BR>If this is an unexpected error or you suspect a script malfunction, please do <A HREF=\"mailto:dblock@vestris.com\">report</A> it.</font>\n";        
  common_footer(CGIStream, 1);
  common_exit(CGIStream);
}

void movefile(const CString& source, const CString& target){  
#ifdef ANSI
  CString all("mv ");
#else
  CString all("move ");
#endif
  all+="\"";
  all+=source;
  all+="\"";
  all+=" ";
  all+="\"";
  all+=target;
  all+="\"";
  system(all.asString());  
}

void make_directory(const CString& dir){
  CString aDir(dir);
#ifdef ANSI    
#ifdef linux
  aDir.remove_backslash();
#endif
  mkdir(aDir.asString(), S_IRWXU);	
#else
  mkdir(aDir.asString());
#endif	  
}

void cgi_init(cgiOutStream& CGIStream, int argc, char * argv[]){
  CGIStream.Lock();
  exec_name = argv[0];
  init_dir = getcwd(NULL, MAXPATHLEN);  
#ifdef ANSI
  ios::sync_with_stdio(0);
#endif
#ifdef _DEBUG
  for(int i=1;i<argc;i++)
    if(!strcmp(argv[i], "debug")) debug = 1;
#endif
  CGIStream << "Content-type: text/html" << (char) 10 << (char) 10;
}

CString int_to_str(int i) { 
  CString iVal; 
  iVal+=i; 
  return iVal; 
}

CString float_to_str(float i){
  char tstr[24]; sprintf(tstr, "%.2f", i);
  return tstr;
}
